
(* msRusage.md	Get resource utilization				*)
(*									*)
(* Stefan Haenssgen 26-oct-92						*)
(*									*)
(* 26-oct-92    First implementation					*)

 
FOREIGN MODULE msRusage;

PROCEDURE RusageUTime()	: LONGREAL;	(* Spent user time in seconds	*)
PROCEDURE RusageSTime()	: LONGREAL;	(* Spent system time in seconds	*)
PROCEDURE RusageTime()	: LONGREAL;	(* Sum of the above		*)
PROCEDURE RusageSwaps()	: LONGINT;	(* Number of swaps		*)
PROCEDURE RusageSize()	: LONGINT;	(* Maximum process size in bytes*)
PROCEDURE RusagePfaults():LONGINT;	(* Number of page faults w. I/O	*)

PROCEDURE RusageStart();		(* Set start for delta measuring*)

PROCEDURE RusageDUTime(): LONGREAL;	(* Spent user time in detla sec	*)
PROCEDURE RusageDSTime(): LONGREAL;	(* Spent system time in delta s	*)
PROCEDURE RusageDTime()	: LONGREAL;	(* Sum of the above		*)
PROCEDURE RusageDSwaps(): LONGINT;	(* Number of swaps since Start()*)
PROCEDURE RusageDSize()	: LONGINT;	(* Maximum process size in bytes*)
PROCEDURE RusageDPfaults():LONGINT;	(* Number of page faults w. I/O	*)

END msRusage.

